struct AscherTableau{ρType, cType, bType, aType}
    rho::ρType
    coef::cType
    b::bType
    acol::aType

    function AscherTableau(rho, coef, b, acol)
        return new{typeof(rho), typeof(coef), typeof(b), typeof(acol)}(rho, coef, b, acol)
    end
end

abstract type AbstractAscher <: AbstractBoundaryValueDiffEqAlgorithm end

for stage in (1, 2, 3, 4, 5, 6, 7)
    alg = Symbol("Ascher$(stage)")

    @eval begin
        """
            $($alg)(; nlsolve = NewtonRaphson(), max_num_subintervals = 3000)

        $($stage)th stage Gauss Legendre collocation methods with adaptivity adapted from Ascher's implementation.

        ## Keyword Arguments

          - `nlsolve`: Internal Nonlinear solver. Any solver which conforms to the SciML
            `NonlinearProblem` interface can be used. Note that any autodiff argument for
            the solver will be ignored and a custom jacobian algorithm will be used.
          - `optimize`: Internal Optimization solver. Any solver which conforms to the SciML
            `OptimizationProblem` interface can be used. Note that any autodiff argument for
            the solver will be ignored and a custom jacobian algorithm will be used.
          - `max_num_subintervals`: Number of maximal subintervals, default as 3000.
          - `zeta`: side condition points, should always be provided.

        !!! note

            For type-stability, the chunksizes for ForwardDiff ADTypes in
            `BVPJacobianAlgorithm` must be provided.

        ## References

        ```bibtex
        @article{Ascher1994CollocationSF,
            title={Collocation Software for Boundary Value Differential-Algebraic Equations},
            author={Uri M. Ascher and Raymond J. Spiteri},
            journal={SIAM J. Sci. Comput.},
            year={1994},
            volume={15},
            pages={938-952},
            url={https://api.semanticscholar.org/CorpusID:10597070}
        }

        @article{Ascher1979ACS,
            title={A collocation solver for mixed order systems of boundary value problems},
            author={Uri M. Ascher and J. Christiansen and Robert D. Russell},
            journal={Mathematics of Computation},
            year={1979},
            volume={33},
            pages={659-679},
            url={https://api.semanticscholar.org/CorpusID:121729124}
        }
        ```
        """
        @kwdef struct $(alg){N, O, J <: BVPJacobianAlgorithm} <: AbstractAscher
            nlsolve::N = nothing
            optimize::O = nothing
            zeta::Vector{Float64} = Float64[]
            jac_alg::J = BVPJacobianAlgorithm()
            max_num_subintervals::Int = 3000
        end
    end
end

function BoundaryValueDiffEqCore.concrete_jacobian_algorithm(
        jac_alg::BVPJacobianAlgorithm, prob::BVProblem, alg::AbstractAscher
    )
    return BVPJacobianAlgorithm(__default_nonsparse_ad(prob.u0))
end

# mesh_selector refine nd redistribute according to the initial mesh
function mesh_selector!(
        cache::AscherCache{iip, T}, z, dmz, mesh, mesh_dt, abstol
    ) where {iip, T}
    (; k, ncomp) = cache
    # weights for mesh selection
    cnsts2 = [
        1.25e-1, 2.604e-3, 8.019e-3, 2.17e-5, 7.453e-5, 5.208e-4, 9.689e-8,
        3.689e-7, 3.1e-6, 2.451e-5, 2.691e-10, 1.12e-9, 1.076e-8, 9.405e-8,
        1.033e-6, 5.097e-13, 2.29e-12, 2.446e-11, 2.331e-10, 2.936e-9, 3.593e-8,
        7.001e-16, 3.363e-15, 3.921e-14, 4.028e-13, 5.646e-12, 7.531e-11, 1.129e-9,
    ]

    koff = Int(k * (k + 1) / 2)
    wgtmsh = 10 * cnsts2[koff]
    root = 1 / (k + 1)
    n = length(mesh) - 1
    slope = Vector{T}(undef, n)
    accum = Vector{T}(undef, n + 1)
    d = Vector{T}(undef, ncomp)
    d1 = similar(d)
    d2 = similar(d)
    # the first interval has to be treated separately from the
    # other intervals (generally the solution on the (i-1)st and ith
    # intervals will be used to approximate the needed derivative, but
    # here the 1st and second intervals are used.)
    hiold = mesh_dt[1]
    @views horder(cache, d1, hiold, dmz[1])
    hiold = mesh_dt[2]
    @views horder(cache, d2, hiold, dmz[2])
    oneovh = 2.0 / (mesh[3] - mesh[1])
    slp = @. (abs(d2 - d1) * wgtmsh * oneovh / (abstol * (T(1) + abs(z[1]))))^root
    slope[1] = maximum(slp)
    slphmx = slope[1] * mesh_dt[1]
    accum[2] = slphmx
    iflip = 1

    # go through the remaining intervals generating slope
    # and  accum
    for i in 2:n
        hiold = mesh_dt[i]
        iflip == -1 && @views horder(cache, d1, hiold, dmz[i])
        iflip == 1 && @views horder(cache, d2, hiold, dmz[i])
        oneovh = 2.0 / (mesh[i + 1] - mesh[i - 1])

        # evaluate function to be equidistributed
        slp = @. (abs(d2 - d1) * wgtmsh * oneovh / (abstol * (T(1) + abs(z[i]))))^root
        slope[i] = maximum(slp)

        # accumulate approximate integral of function to be equidistributed
        temp = slope[i] * hiold
        slphmx = max(slphmx, temp)
        accum[i + 1] = accum[i] + temp
        iflip = -iflip
    end

    avrg = accum[n + 1] / n
    # `degequ` is the degree of equidistribution which then is used to
    # determine whether the mesh redistribution is worthwhile or just
    # halving the mesh is enough.
    degequ = avrg / max(slphmx, eps(T))

    # expected n to achieve 0.1x user requested tolerances
    naccum = floor(Int, accum[n + 1] + 1)

    # decide if mesh selection is worthwhile (otherwise, directly halving mesh is enough)
    if (avrg < eps(T)) || (degequ >= 0.5)
        # Just continue with utilizing the halved mesh which was used for error estimation
        return
    else
        redistribute!(cache, length(cache.original_mesh), naccum, slope, accum)
    end
end

function redistribute!(
        cache::AscherCache{iip, T}, nold::I, naccum::I,
        slope::Vector{T}, accum::Vector{T}
    ) where {iip, T, I <: Integer}
    (; prob, fixpnt, mesh, mesh_dt) = cache
    n::Int = length(slope)
    nmax = copy(n)
    mesh_old = copy(cache.original_mesh)
    # nmx assures mesh has at least half as many subintervals as the
    # previous mesh
    nmx = max(nold + 1, naccum) / 2

    # assures that halving will be possible later
    nmax2 = nmax / 2

    # the mesh is at most halved
    n = min(nmax2, nold, nmx)

    noldp1 = nold + 1
    nfxp1 = length(fixpnt) + 1
    # ensure that fixpnt is included in the new mesh
    (n < nfxp1) && (n = nfxp1)

    # having decided to generate a new mesh with n subintervals we now
    # do so, taking into account that the nfxpnt points in the array
    # fixpnt must be included in the new mesh.
    inn = 1
    accl = T(0)
    lold = 2
    lcarry = 0
    lnew = 0
    resize!(mesh, n + 1)
    mesh[1] = first(prob.tspan)
    mesh[n + 1] = last(prob.tspan)

    for i in 1:nfxp1
        if i !== nfxp1
            for j in lold:noldp1
                lnew = j
                (fixpnt[i] <= mesh_old[j]) && break
            end
            accr = accum[lnew] + (fixpnt[i] - mesh_old[lnew]) * slope[lnew - 1]
            nregn = (accr - accl) / accum[noldp1] * n - T(0.5)
            nregn = min(nregn, n - inn - nfxp1 + i)
            mesh[inn + nregn + 1] = fixpnt[i]
        else
            accr = accum[noldp1]
            lnew = noldp1
            nregn = n - inn
        end
        if nregn !== 0
            temp = accl
            tsum = (accr - accl) / (nregn + 1)
            for j in 1:nregn
                inn = inn + 1
                temp = temp + tsum
                for l in lold:lnew
                    lcarry = l
                    (temp <= accum[l]) && break
                end
                lold = lcarry
                mesh[inn] = mesh_old[lold - 1] + (temp - accum[lold - 1]) / slope[lold - 1]
            end
        end
        inn = inn + 1
        accl = accr
        lold = lnew
    end
    return mesh_dt = diff(mesh)
end

function halve_mesh!(cache::AscherCache)
    (; mesh, mesh_dt, valstr) = cache
    n = length(mesh) - 1
    old_mesh = copy(mesh)
    for i in 1:n
        x = mesh[i]
        hd6 = mesh_dt[i] / 6.0
        for j in 1:4
            x = x + hd6
            (j == 3) && (x = x + hd6)
            @views approx(cache, x, valstr[i][j])
        end
    end

    # halve the current mesh
    N = 2 * n
    resize!(mesh, N + 1)
    resize!(mesh_dt, N)
    mesh[1] = old_mesh[1]

    for i in 1:n
        mesh[2i] = (old_mesh[i] + old_mesh[i + 1]) / 2.0
        mesh[2i + 1] = old_mesh[i + 1]
    end
    return mesh_dt[1:end] = diff(mesh)[1:end]
end

# determine the error estimate and test to see if the
# error tolerances are satisfied
function error_estimate!(cache::AscherCache)
    (; k, valstr, mesh, mesh_dt, error) = cache
    # weights for extrapolation error estimate
    cnsts1 = [
        0.25e0, 0.625e-1, 7.2169e-2, 1.8342e-2, 1.9065e-2, 5.819e-2, 5.4658e-3,
        5.337e-3, 1.889e-2, 2.7792e-2, 1.6095e-3, 1.4964e-3, 7.5938e-3, 5.7573e-3,
        1.8342e-2, 4.673e-3, 4.15e-4, 1.919e-3, 1.468e-3, 6.371e-3, 4.61e-3,
        1.342e-4, 1.138e-4, 4.889e-4, 4.177e-4, 1.374e-3, 1.654e-3, 2.863e-3,
    ]
    # assign weights for error estimate
    koff = Int(k * (k + 1) / 2)
    wgterr = cnsts1[koff]
    n = length(mesh) - 1

    # error estimates are to be generated and tested
    # to see if the tolerance requirements are satisfied.
    for i in n:-1:1
        # the error estimates are obtained by combining values of the numerical solutions for two meshes.
        # for each value of iback we will consider the two approximation at 2 points in each of
        # the new subintervals. we work backwards through the subinterval so that new values can be stored
        # in valstr in case they prove to be needed later for an error estimate.
        x = mesh[i] + (mesh_dt[i]) * 2.0 / 3.0
        @views approx(cache, x, valstr[i][3])
        error[i] .= wgterr .* abs.(
            valstr[i][3] .-
                (isodd(i) ? valstr[Int((i + 1) / 2)][2] : valstr[Int(i / 2)][4])
        )

        x = mesh[i] + (mesh_dt[i]) / 3.0
        @views approx(cache, x, valstr[i][2])
        error[i] .= error[i] .+
            wgterr .* abs.(
            valstr[i][2] .-
                (isodd(i) ? valstr[Int((i + 1) / 2)][1] : valstr[Int(i / 2)][3])
        )
    end
    return maximum(reduce(hcat, error), dims = 2)
end

# determine highest order (piecewise constant) derivatives
# of the current collocation solution
function horder(cache::AscherCache, uhigh, hi, dmzi)
    (; ncomp, k, TU) = cache
    (; coef) = TU
    dn = 1.0 / hi^(k - 1)
    uhigh[1:ncomp] .= 0.0

    idmz = 1
    vdmzi = reduce(vcat, dmzi)
    for j in 1:k
        fact = dn * coef[1, j]
        for id in 1:ncomp
            uhigh[id] = uhigh[id] + fact * vdmzi[idmz]
            idmz = idmz + 1
        end
    end
    return
end

for stage in (1, 2, 3, 4, 5, 6, 7)
    alg = Symbol("Ascher$(stage)")
    @eval alg_stage(::$(alg)) = $stage
end

for stage in (1, 2, 3, 4, 5, 6, 7)
    alg = Symbol("Ascher$(stage)")
    @eval alg_order(::$(alg)) = $(2 * stage)
end

SciMLBase.isadaptive(alg::AbstractAscher) = true

module BoundaryValueDiffEqAscher

using ADTypes: ADTypes, AutoSparse, AutoForwardDiff
using AlmostBlockDiagonals: AlmostBlockDiagonals, IntermediateAlmostBlockDiagonal

using BoundaryValueDiffEqCore: AbstractBoundaryValueDiffEqAlgorithm,
    AbstractBoundaryValueDiffEqCache, BVPJacobianAlgorithm,
    __extract_problem_details, concrete_jacobian_algorithm,
    __Fix3, __concrete_solve_algorithm,
    __internal_nlsolve_problem, __vec, __vec_f, __vec_f!,
    __vec_bc, __vec_bc!, __extract_mesh, get_dense_ad,
    __get_bcresid_prototype, __split_kwargs, __concrete_kwargs,
    __default_nonsparse_ad, __construct_internal_problem,
    __internal_solve, __build_cost

using ConcreteStructs: @concrete
using DifferentiationInterface: DifferentiationInterface, Constant, prepare_jacobian
using FastClosures: @closure
using ForwardDiff: ForwardDiff, Dual
using LinearAlgebra
using PreallocationTools: PreallocationTools, DiffCache
using RecursiveArrayTools: VectorOfArray, recursivecopy
using Reexport: @reexport
using SciMLBase: SciMLBase, AbstractDiffEqInterpolation, StandardBVProblem, __solve,
    _unwrap_val
using Setfield: @set!

const DI = DifferentiationInterface

@reexport using ADTypes, BoundaryValueDiffEqCore, SciMLBase

include("types.jl")
include("utils.jl")
include("algorithms.jl")
include("alg_utils.jl")
include("ascher_tableaus.jl")
include("ascher.jl")
include("adaptivity.jl")
include("collocation.jl")

export Ascher1, Ascher2, Ascher3, Ascher4, Ascher5, Ascher6, Ascher7

end # module BoundaryValueDiffEqAscher

function constructAscher(alg::Ascher1, ::Type{T}) where {T}
    # initialization
    k = alg_stage(alg)
    coef = zeros(k, k) + I
    acol = Matrix{T}(undef, k, k)

    # collocation points
    rho = [1 // 2]
    # find runge-kutta coefficients b, acol
    for j in 1:k
        @views vmonde!(rho, coef[:, j], k)
    end
    for i in 1:k
        @views rkbas!(rho[i], coef, k, acol[:, i])
    end
    b = [1]
    return AscherTableau(rho, coef, b, acol)
end
function constructAscher(alg::Ascher2, ::Type{T}) where {T}
    k = alg_stage(alg)
    coef = zeros(k, k) + I
    acol = Matrix{T}(undef, k, k)

    # Gauss Legendre collocation points
    rho = [1 // 2 - Rational(sqrt(3)) // 6, 1 // 2 + Rational(sqrt(3)) // 6]

    # find runge-kutta coefficients b, acol
    for j in 1:k
        @views vmonde!(rho, coef[:, j], k)
    end
    for i in 1:k
        @views rkbas!(rho[i], coef, k, acol[:, i])
    end
    b = [1 // 2, 1 // 2]
    return AscherTableau(rho, coef, b, acol)
end
function constructAscher(alg::Ascher3, ::Type{T}) where {T}
    k = alg_stage(alg)
    coef = zeros(k, k) + I
    acol = Matrix{T}(undef, k, k)

    # Gauss Legendre collocation points
    rho = [1 // 2 - Rational(sqrt(15)) // 10, 1 // 2, 1 // 2 + Rational(sqrt(15)) // 10]

    # find runge-kutta coefficients b, acol
    for j in 1:k
        @views vmonde!(rho, coef[:, j], k)
    end
    for i in 1:k
        @views rkbas!(rho[i], coef, k, acol[:, i])
    end
    b = [5 // 18, 4 // 9, 5 // 18]
    return AscherTableau(rho, coef, b, acol)
end
function constructAscher(alg::Ascher4, ::Type{T}) where {T}
    k = alg_stage(alg)
    coef = zeros(k, k) + I
    b = Vector{T}(undef, k)
    acol = Matrix{T}(undef, k, k)

    # Gauss Legendre collocation points
    rho = [
        0.06943184420297371373, 0.33000947820757187134,
        0.66999052179242812866, 0.93056815579702628627,
    ]

    # find runge-kutta coefficients b, acol
    for j in 1:k
        @views vmonde!(rho, coef[:, j], k)
    end
    for i in 1:k
        @views rkbas!(rho[i], coef, k, acol[:, i])
    end
    @views rkbas!(1.0, coef, k, b)
    return AscherTableau(rho, coef, b, acol)
end
function constructAscher(alg::Ascher5, ::Type{T}) where {T}
    k = alg_stage(alg)
    coef = zeros(k, k) + I
    b = Vector{T}(undef, k)
    acol = Matrix{T}(undef, k, k)

    # Gauss Legendre collocation points
    rho = [
        0.04691007703066801815, 0.23076534494715844614, 0.5,
        0.76923465505284155386, 0.95308992296933198185,
    ]

    # find runge-kutta coefficients b, acol
    for j in 1:k
        @views vmonde!(rho, coef[:, j], k)
    end
    for i in 1:k
        @views rkbas!(rho[i], coef, k, acol[:, i])
    end
    @views rkbas!(1.0, coef, k, b)
    return AscherTableau(rho, coef, b, acol)
end
function constructAscher(alg::Ascher6, ::Type{T}) where {T}
    k = alg_stage(alg)
    coef = zeros(k, k) + I
    b = Vector{T}(undef, k)
    acol = Matrix{T}(undef, k, k)

    # Gauss Legendre collocation points
    rho = [
        0.03376524289842397497, 0.16939530676686775923, 0.38069040695840154764,
        0.61930959304159845236, 0.83060469323313224077, 0.96623475710157602503,
    ]

    # find runge-kutta coefficients b, acol
    for j in 1:k
        @views vmonde!(rho, coef[:, j], k)
    end
    for i in 1:k
        @views rkbas!(rho[i], coef, k, acol[:, i])
    end
    @views rkbas!(1.0, coef, k, b)
    return AscherTableau(rho, coef, b, acol)
end
function constructAscher(alg::Ascher7, ::Type{T}) where {T}
    k = alg_stage(alg)
    coef = zeros(k, k) + I
    b = Vector{T}(undef, k)
    acol = Matrix{T}(undef, k, k)

    # Gauss Legendre collocation points
    rho = [
        0.02544600438286209743, 0.12923440720030276996, 0.29707742431130140792, 0.5,
        0.70292257568869859208, 0.87076559279969723004, 0.97455399561713790257,
    ]
    # find runge-kutta coefficients b, acol
    for j in 1:k
        @views vmonde!(rho, coef[:, j], k)
    end
    for i in 1:k
        @views rkbas!(rho[i], coef, k, acol[:, i])
    end
    @views rkbas!(1.0, coef, k, b)
    return AscherTableau(rho, coef, b, acol)
end

# Solve vandermonde system v*x=e
# with v(i,j)=rho(j)**(i-1)/(i-1)!
function vmonde!(rho, coef, k)
    (k == 1) && return
    for i in 1:(k - 1)
        for j in 1:(k - i)
            coef[j] = (coef[j + 1] - coef[j]) / (rho[j + i] - rho[j])
        end
    end
    ifac = 1
    for i in 1:(k - 1)
        kmi = k + 1 - i
        for j in 2:kmi
            coef[j] = coef[j] - rho[j + i - 1] * coef[j - 1]
        end
        coef[kmi] = ifac * coef[kmi]
        ifac = ifac * i
    end
    return coef[1] = ifac * coef[1]
end

function rkbas!(s, coef, k::Integer, rkb, dm)
    # for more gauss collocation points per subinterval
    if k == 1
        rkb[1] = 1.0
        dm[1] = 1.0
        return
    end
    t = s ./ (1:k)
    for i in 1:k
        p = coef[1, i]
        for j in 2:k
            p = p * t[k + 2 - j] + coef[j, i]
        end
        rkb[i] = p
    end
    for i in 1:k
        p = coef[1, i]
        for j in 2:k
            p = p * t[k + 1 - j] + coef[j, i]
        end
        dm[i] = p
    end
    return
end

function rkbas!(s, coef, k::Integer, rkb)
    # for more gauss collocation points per subinterval
    if k == 1
        rkb[1] = 1.0
        return
    end
    t = s ./ (1:k)
    for i in 1:k
        p = coef[1, i]
        for j in 2:k
            p = p * t[k + 2 - j] + coef[j, i]
        end
        rkb[i] = p
    end
    return
end

function build_almost_block_diagonals(zeta::Vector{T}, ncomp::I, mesh, ::Type{T}) where {
        T, I,
    }
    lside = 0
    ncol = 2 * ncomp
    n = length(mesh) - 1
    # build integs (describing block structure of matrix)
    rows = Vector{I}(undef, n)
    cols = repeat([ncol], n)
    lasts = repeat([ncomp], n)
    let lside = 0
        for i in 1:(n - 1)
            lside = first(findall(x::Float64 -> x > mesh[i], zeta)) - 1
            rows[i] = ncomp + lside
        end
    end
    lasts[end] = ncol
    rows[end] = ncol
    g = IntermediateAlmostBlockDiagonal([zeros(rows[i], cols[i]) for i in 1:n], lasts)
    return g
end

# Custom pivot LU factorization and substitution for simple usage and
# customized array types
function __factorize!(a::Matrix{T}, ipvt::Vector) where {T}
    t = 0.0
    n = size(a, 1)
    if n - 1 >= 1
        for k in 1:(n - 1)
            kp1 = k + 1
            # find l = pivot index
            l = argmax(abs.(a[k:end, k])) + k - 1
            ipvt[k] = l
            # zero pivot implies this column already triangularized
            if a[l, k] !== 0
                # interchange if necessary
                if l !== k
                    t = a[l, k]
                    a[l, k] = a[k, k]
                    a[k, k] = t
                end
                # compute  multipliers
                t = -1.0 / a[k, k]
                @views a[(k + 1):end, k] .= a[(k + 1):end, k] .* t
                # row elimination with column indexing
                for j in kp1:n
                    t = a[l, j]
                    if l !== k
                        a[l, j] = a[k, j]
                        a[k, j] = t
                    end
                    @views __muladd!(t, a[(k + 1):end, k], a[(k + 1):end, j])
                end
            end
        end
    end
    return ipvt[n] = n
end

function __substitute!(a::Matrix{T1}, ipvt::Vector{I}, vb::Vector{Vector{T2}}) where {
        T1, T2, I,
    }
    n = size(a, 1)
    b = reduce(vcat, vb)
    if n - 1 >= 1
        for k in 1:(n - 1)
            l::I = ipvt[k]
            t = b[l]
            if l !== k
                b[l] = b[k]
                b[k] = t
            end
            @views __muladd!(t, a[(k + 1):end, k], b[(k + 1):end])
        end
    end
    for k in n:-1:1
        b[k] = b[k] / a[k, k]
        @views __muladd!(-b[k], a[1:(k - 1), k], b[1:(k - 1)])
    end
    return recursive_unflatten!(vb, b)
end
function __substitute!(a::Matrix{T1}, ipvt::Vector{I}, b::AbstractVector{T2}) where {
        T1, T2 <: Real, I,
    }
    n = size(a, 1)
    if n - 1 >= 1
        for k in 1:(n - 1)
            l::I = ipvt[k]
            t = b[l]
            if l !== k
                b[l] = b[k]
                b[k] = t
            end
            @views __muladd!(t, a[(k + 1):end, k], b[(k + 1):end])
        end
    end
    for k in n:-1:1
        b[k] = b[k] / a[k, k]
        @views __muladd!(-b[k], a[1:(k - 1), k], b[1:(k - 1)])
    end
    return
end

@inline function __muladd!(a, x, y)
    return y .= muladd.(a, x, y)
end

@views function recursive_flatten!(y::Vector, x::Vector{Vector{Vector{T}}}) where {T}
    i = 0
    for xᵢ in x
        for xᵢᵢ in xᵢ
            copyto!(y[(i + 1):(i + length(xᵢᵢ))], xᵢᵢ)
            i += length(xᵢᵢ)
        end
    end
    return nothing
end

@views function recursive_flatten!(y::AbstractArray, x::Vector{Vector{T}}) where {T}
    i = 0
    for xᵢ in x
        copyto!(y[(i + 1):(i + length(xᵢ))], xᵢ)
        i += length(xᵢ)
    end
    return nothing
end

@views function recursive_flatten!(y::Vector, x::Vector{Vector{T}}) where {
        T <:
        ForwardDiff.Dual,
    }
    i = 0
    for xᵢ in x
        copyto!(y[(i + 1):(i + length(xᵢ))], xᵢ)
        i += length(xᵢ)
    end
    return nothing
end

@views function recursive_unflatten!(y::Vector{Vector{Vector{T}}}, x::Vector) where {T}
    i = 0
    for yᵢ in y
        for yᵢᵢ in yᵢ
            copyto!(yᵢᵢ, x[(i + 1):(i + length(yᵢᵢ))])
            i += length(yᵢᵢ)
        end
    end
    return nothing
end
@views function recursive_unflatten!(y::Vector{Vector{T}}, x::Vector) where {T}
    i = 0
    for yᵢ in y
        copyto!(yᵢ, x[(i + 1):(i + length(yᵢ))])
        i += length(yᵢ)
    end
    return nothing
end
@views function recursive_unflatten!(y::AbstractArray, x::Vector{T}) where {T}
    i = 0
    for yᵢ in y
        copyto!(yᵢ, x[(i + 1):(i + length(yᵢ))])
        i += length(yᵢ)
    end
    return nothing
end

@inline function construct_bc_jac(prob::BVProblem)
    return construct_bc_jac(prob, __get_bcresid_prototype(prob, prob.u0), prob.problem_type)
end
@inline function construct_bc_jac(prob::BVProblem, _, pt::StandardBVProblem)
    if isinplace(prob)
        bcjac = (df, u, p, t) -> begin
            _du = similar(u)
            prob.f.bc(_du, u, p, t)
            _f = @closure (du, u) -> prob.f.bc(du, u, p, t)
            ForwardDiff.jacobian!(df, _f, _du, u)
            return
        end
    else
        bcjac = (df, u, p, t) -> begin
            _du = prob.f.bc(u, p, t)
            _f = @closure (du, u) -> (du .= prob.f.bc(u, p, t))
            ForwardDiff.jacobian!(df, _f, _du, u)
            return
        end
    end
    return bcjac
end

@inline function construct_bc_jac(prob::BVProblem, bcresid_prototype, pt::TwoPointBVProblem)
    return if isinplace(prob)
        bcjac = (df, u, p) -> begin
            _du = similar(u)
            La = length(first(bcresid_prototype))
            @views first(prob.f.bc)(_du[1:La], u, p)
            @views last(prob.f.bc)(_du[(La + 1):end], u, p)
            _f = function (du, u)
                @views first(prob.f.bc)(du[1:La], u, p)
                return @views last(prob.f.bc)(du[(La + 1):end], u, p)
            end
            ForwardDiff.jacobian!(df, _f, _du, u)
            return
        end
    else
        bcjac = (df, u, p) -> begin
            La = length(first(bcresid_prototype))
            _dua = first(prob.f.bc)(u, p)
            _dub = last(prob.f.bc)(u, p)
            _f = function (du, u)
                dua = first(prob.f.bc)(u, p)
                dub = last(prob.f.bc)(u, p)
                return du .= vcat(dua, dub)
            end
            ForwardDiff.jacobian!(df, _f, vcat(_dua, _dub), u)
            return
        end
    end
end

function Φ!(cache::AscherCache{iip, T}, z, res, pt::StandardBVProblem) where {iip, T}
    (;
        f, mesh, mesh_dt, ncomp, ny, bc, k, p, zeta, residual, zval,
        yval, gval, delz, dmz, deldmz, g, w, v, ipvtg, ipvtw, TU,
    ) = cache
    (; acol, rho) = TU
    ncy = ncomp + ny
    n = length(mesh) - 1
    Tz = eltype(z)
    dgz = similar(zval)
    df = zeros(T, ncy, ncy)
    dmzo = copy(deldmz)

    temp_rhs = [[Vector{T}(undef, ncy) for _ in 1:k] for _ in 1:n]
    temp_z = [Vector{Tz}(undef, ncomp) for _ in 1:(n + 1)]
    recursive_unflatten!(temp_z, z)
    rhs_bc = similar(zval)

    # zero the matrices to be computed
    fill!.(w, T(0))

    izeta = 1
    izsave = 1
    # set up the linear system of equations
    for i in 1:n
        # construct a block of a and a corresponding piece of rhs
        xii = mesh[i]
        h = mesh_dt[i]
        @views approx(cache, xii, zval)
        # find rhs boundary value
        @views bc(gval, zval, p, xii)
        # go thru the ncomp collocation equations and side conditions
        # in the i-th subinterval
        while true
            (izeta > ncomp) && break
            (zeta[izeta] > xii + eps(T)) && break
            rhs_bc[izeta] = -gval[izeta]
            # build a row of a corresponding to a boundary point
            @views gderiv(cache, g[i], izeta, zval, dgz, 1, izeta, pt)
            izeta = izeta + 1
        end

        # assemble collocation equations
        for j in 1:k
            hrho = h * rho[j]
            xcol = xii + hrho
            # find rhs values
            @views approx(cache, xcol, zval, yval, dmzo[i][j][1:ncomp])
            uval = vcat(zval, yval)

            @views f(residual, uval, p, xcol)
            dmzo[i][j][(ncomp + 1):ncy] .= T(0)
            temp_rhs[i][j] .= residual .- dmzo[i][j]

            # fill in ncy rows of  w and v
            @views vwblok(
                cache, xcol, hrho, j, w[i], v[i], ipvtw[i], uval, df, acol[:, j], dmzo[i]
            )
        end

        @views gblock!(cache, h, g[i], izeta, w[i], v[i])

        if i >= n
            izsave = izeta
            # build equation for a side condition.
            # other nonlinear case
            zval = __get_value(cache.z[n + 1])
            @views bc(gval, zval, p, mesh[i + 1])
            while true
                (izeta > ncomp) && break
                # find rhs boundary value
                rhs_bc[izeta] = -gval[izeta]
                # build a row of  a  corresponding to a boundary point
                @views gderiv(cache, g[i], izeta + ncomp, zval, dgz, 2, izeta, pt)
                izeta = izeta + 1
            end
        end
    end

    # assembly process completed
    # solve the linear system
    # AND matrix decomposition
    @views AlmostBlockDiagonals.factor_shift(g, ipvtg, df)

    # perform forward and backward substitution.
    deldmz .= copy(temp_rhs)
    izet = 1
    for i in 1:n
        nrow = g.rows[i]
        izeta = nrow + 1 - ncomp
        (i == n) && (izeta = izsave)
        while true
            (izet == izeta) && break
            delz[i][izet] = rhs_bc[izet]
            izet = izet + 1
        end
        h = mesh_dt[i]
        @views gblock!(cache, h, izeta, w[i], delz[i:(i + 1)], deldmz[i], ipvtw[i])

        if i == n
            while true
                (izet > ncomp) && break
                delz[i + 1][izet] = rhs_bc[izet]
                izet = izet + 1
            end
        end
    end
    # perform forward and backward substitution
    @views AlmostBlockDiagonals.substitution(g, ipvtg, delz)

    # finally find deldmz
    @views dmzsol!(cache, v, delz, deldmz)

    # project current iterate into current pp-space
    dmz .= copy(dmzo)
    izet::Int = 1
    for i in 1:n
        nrow = g.rows[i]
        izeta::Int = nrow + 1 - ncomp
        (i == n) && (izeta = izsave)
        while true
            (izet == izeta) && break
            temp_z[i][izet] = dgz[izet]
            izet = izet + 1
        end
        h = mesh_dt[i]
        @views gblock!(cache, h, izeta, w[i], temp_z[i:(i + 1)], dmz[i], ipvtw[i])

        if i == n
            while true
                (izet > ncomp) && break
                temp_z[i + 1][izet] = dgz[izet]
                izet = izet + 1
            end
        end
    end

    @views AlmostBlockDiagonals.substitution(g, ipvtg, temp_z)

    # finally find dmz
    @views dmzsol!(cache, v, temp_z, dmz)

    temp_z .= temp_z .+ delz
    dmz .= dmz .+ deldmz

    resids = [Vector{T}(undef, ncy) for _ in 1:(n + 1)]
    for (i, item) in enumerate(temp_rhs)
        for (j, col) in enumerate(eachrow(reduce(hcat, item)))
            resids[i][j] = sum(abs2, col)
        end
    end
    recursive_flatten!(z, temp_z)
    residss = [r[1:ncomp] for r in resids]
    recursive_flatten!(res, residss)

    # update z in cache for next iteration
    new_z = __get_value(temp_z)
    copyto!(cache.z, new_z)
    return copyto!(cache.dmz, dmz)
end

function Φ!(cache::AscherCache{iip, T}, z, res, pt::TwoPointBVProblem) where {iip, T}
    (;
        f, mesh, mesh_dt, ncomp, ny, bc, k, p, zeta, bcresid_prototype, residual,
        zval, yval, gval, delz, dmz, deldmz, g, w, v, dmzo, ipvtg, ipvtw, TU,
    ) = cache
    (; acol, rho) = TU
    ncy = ncomp + ny
    n = length(mesh) - 1
    Tz = eltype(z)
    dgz = similar(zval)
    df = zeros(T, ncy, ncy)
    La = length(first(bcresid_prototype))

    temp_rhs = [[Vector{T}(undef, ncy) for _ in 1:k] for _ in 1:n]
    temp_z = [Vector{Tz}(undef, ncomp) for _ in 1:(n + 1)]
    recursive_unflatten!(temp_z, z)
    rhs_bc = similar(zval)

    # zero the matrices to be computed
    fill!.(w, T(0))

    izeta = 1
    izsave = 1
    # set up the linear system of equations
    for i in 1:n
        # construct a block of a and a corresponding piece of rhs
        xii = mesh[i]
        h = mesh_dt[i]
        @views approx(cache, xii, zval)
        # find rhs boundary value
        @views first(bc)(gval[1:La], zval, p)
        @views last(bc)(gval[(La + 1):end], zval, p)
        # go thru the ncomp collocation equations and side conditions
        # in the i-th subinterval
        while true
            (izeta > ncomp) && break
            (zeta[izeta] > xii + eps(T)) && break
            rhs_bc[izeta] = -gval[izeta]
            # build a row of a corresponding to a boundary point
            @views gderiv(cache, g[i], izeta, zval, dgz, 1, izeta, pt)
            izeta = izeta + 1
        end
        #TODO: whether the previous snippet could be available when i==1 for TwoPointBVProblem?
        # assemble collocation equations
        for j in 1:k
            hrho = h * rho[j]
            xcol = xii + hrho
            # find rhs values
            @views approx(cache, xcol, zval, yval, dmzo[i][j][1:ncomp])
            uval = vcat(zval, yval)

            @views f(residual, uval, p, xcol)
            dmzo[i][j][(ncomp + 1):ncy] .= T(0)
            temp_rhs[i][j] .= residual .- dmzo[i][j]

            # fill in ncy rows of  w and v
            @views vwblok(
                cache, xcol, hrho, j, w[i], v[i], ipvtw[i], uval, df, acol[:, j], dmzo[i]
            )
        end

        @views gblock!(cache, h, g[i], izeta, w[i], v[i])

        if i >= n
            izsave = izeta
            # build equation for a side condition.
            # other nonlinear case
            zval = __get_value(cache.z[n + 1])
            @views first(bc)(gval[1:La], zval, p)
            @views last(bc)(gval[(La + 1):end], zval, p)
            while true
                (izeta > ncomp) && break
                # find rhs boundary value
                rhs_bc[izeta] = -gval[izeta]
                # build a row of  a  corresponding to a boundary point
                @views gderiv(cache, g[i], izeta + ncomp, zval, dgz, 2, izeta, pt)
                izeta = izeta + 1
            end
        end
    end

    # assembly process completed
    # solve the linear system
    # matrix decomposition
    @views AlmostBlockDiagonals.factor_shift(g, ipvtg, df)

    # perform forward and backward substitution.
    deldmz .= copy(temp_rhs)
    izet = 1
    for i in 1:n
        nrow = g.rows[i]
        izeta = nrow + 1 - ncomp
        (i == n) && (izeta = izsave)
        while true
            (izet == izeta) && break
            delz[i][izet] = rhs_bc[izet]
            izet = izet + 1
        end
        h = mesh_dt[i]
        @views gblock!(cache, h, izeta, w[i], delz[i:(i + 1)], deldmz[i], ipvtw[i])

        if i == n
            while true
                (izet > ncomp) && break
                delz[i + 1][izet] = rhs_bc[izet]
                izet = izet + 1
            end
        end
    end
    # perform forward and backward substitution
    @views AlmostBlockDiagonals.substitution(g, ipvtg, delz)

    # finally find deldmz
    @views dmzsol!(cache, v, delz, deldmz)

    # project current iterate into current pp-space
    dmz .= copy(dmzo)
    izet::Int = 1
    for i in 1:n
        nrow = g.rows[i]
        izeta::Int = nrow + 1 - ncomp
        (i == n) && (izeta = izsave)
        while true
            (izet == izeta) && break
            temp_z[i][izet] = dgz[izet]
            izet = izet + 1
        end
        h = mesh_dt[i]
        @views gblock!(cache, h, izeta, w[i], temp_z[i:(i + 1)], dmz[i], ipvtw[i])

        if i == n
            while true
                (izet > ncomp) && break
                temp_z[i + 1][izet] = dgz[izet]
                izet = izet + 1
            end
        end
    end

    @views AlmostBlockDiagonals.substitution(g, ipvtg, temp_z)

    # finally find dmz
    @views dmzsol!(cache, v, temp_z, dmz)

    temp_z .= temp_z .+ delz
    dmz .= dmz .+ deldmz

    resids = [Vector{T}(undef, ncy) for _ in 1:(n + 1)]
    for (i, item) in enumerate(temp_rhs)
        for (j, col) in enumerate(eachrow(reduce(hcat, item)))
            resids[i][j] = sum(abs2, col)
        end
    end
    recursive_flatten!(z, temp_z)
    residss = [r[1:ncomp] for r in resids]
    recursive_flatten!(res, residss)

    # update z in cache for next iteration
    new_z = __get_value(temp_z)
    copyto!(cache.z, new_z)
    return copyto!(cache.dmz, dmz)
end

@inline __get_value(z::Vector{<:AbstractArray}) = eltype(first(z)) <: ForwardDiff.Dual ?
    [map(x -> x.value, a) for a in z] : z
@inline __get_value(z) = isa(z, ForwardDiff.Dual) ? z.value : z

function Φ(cache::AscherCache{iip, T}, z, pt::StandardBVProblem) where {iip, T}
    (;
        f, mesh, mesh_dt, ncomp, ny, bc, k, p, zeta, residual, zval, yval,
        gval, delz, dmz, deldmz, g, w, v, dmzo, ipvtg, ipvtw, TU,
    ) = cache
    (; acol, rho) = TU
    ncy = ncomp + ny
    n = length(mesh) - 1
    Tz = eltype(z)
    dgz = similar(zval)
    df = Matrix{T}(undef, ncy, ncy)

    temp_rhs = [[Vector{T}(undef, ncy) for _ in 1:k] for _ in 1:n]
    temp_z = [Vector{Tz}(undef, ncomp) for _ in 1:(n + 1)]
    recursive_unflatten!(temp_z, z)
    rhs_bc = similar(zval)

    # zero the matrices to be computed
    fill!.(w, T(0))

    izeta = 1
    izsave = 1
    # set up the linear system of equations
    for i in 1:n
        # construct a block of a and a corresponding piece of rhs
        xii = mesh[i]
        h = mesh_dt[i]
        @views approx(cache, xii, zval)
        # find rhs boundary value
        gval = bc(zval, p, xii)
        # go thru the ncomp collocation equations and side conditions
        # in the i-th subinterval
        while true
            (izeta > ncomp) && break
            (zeta[izeta] > xii + eps(T)) && break
            rhs_bc[izeta] = -gval[izeta]
            # build a row of a corresponding to a boundary point
            @views gderiv(cache, g[i], izeta, zval, dgz, 1, izeta, pt)
            izeta = izeta + 1
        end

        # assemble collocation equations
        for j in 1:k
            hrho = h * rho[j]
            xcol = xii + hrho
            # find rhs values
            @views approx(cache, xcol, zval, yval, dmzo[i][j][1:ncomp])
            uval = vcat(zval, yval)

            residual = f(uval, p, xcol)
            dmzo[i][j][(ncomp + 1):ncy] .= T(0)
            temp_rhs[i][j] .= residual .- dmzo[i][j]

            # fill in ncy rows of  w and v
            @views vwblok(
                cache, xcol, hrho, j, w[i], v[i], ipvtw[i], uval, df, acol[:, j], dmzo[i]
            )
        end

        @views gblock!(cache, h, g[i], izeta, w[i], v[i])

        if i >= n
            izsave = izeta
            # build equation for a side condition.
            # other nonlinear case
            zval = __get_value(cache.z[n + 1])
            gval = bc(zval, p, mesh[i + 1])
            while true
                (izeta > ncomp) && break
                # find rhs boundary value
                rhs_bc[izeta] = -gval[izeta]
                # build a row of  a  corresponding to a boundary point
                @views gderiv(cache, g[i], izeta + ncomp, zval, dgz, 2, izeta, pt)
                izeta = izeta + 1
            end
        end
    end

    # assembly process completed
    # solve the linear system
    # matrix decomposition
    @views AlmostBlockDiagonals.factor_shift(g, ipvtg, df)

    # perform forward and backward substitution.
    deldmz .= copy(temp_rhs)
    izet = 1
    for i in 1:n
        nrow = g.rows[i]
        izeta = nrow + 1 - ncomp
        (i == n) && (izeta = izsave)
        while true
            (izet == izeta) && break
            delz[i][izet] = rhs_bc[izet]
            izet = izet + 1
        end
        h = mesh_dt[i]
        @views gblock!(cache, h, izeta, w[i], delz[i:(i + 1)], deldmz[i], ipvtw[i])

        if i == n
            while true
                (izet > ncomp) && break
                delz[i + 1][izet] = rhs_bc[izet]
                izet = izet + 1
            end
        end
    end
    # perform forward and backward substitution
    @views AlmostBlockDiagonals.substitution(g, ipvtg, delz)

    # finally find deldmz
    @views dmzsol!(cache, v, delz, deldmz)

    # project current iterate into current pp-space
    dmz .= copy(dmzo)
    izet::Int = 1
    for i in 1:n
        nrow = g.rows[i]
        izeta::Int = nrow + 1 - ncomp
        (i == n) && (izeta = izsave)
        while true
            (izet == izeta) && break
            temp_z[i][izet] = dgz[izet]
            izet = izet + 1
        end
        h = mesh_dt[i]
        @views gblock!(cache, h, izeta, w[i], temp_z[i:(i + 1)], dmz[i], ipvtw[i])

        if i == n
            while true
                (izet > ncomp) && break
                temp_z[i + 1][izet] = dgz[izet]
                izet = izet + 1
            end
        end
    end

    @views AlmostBlockDiagonals.substitution(g, ipvtg, temp_z)

    # finally find dmz
    @views dmzsol!(cache, v, temp_z, dmz)

    temp_z .= temp_z .+ delz
    dmz .= dmz .+ deldmz

    resids = [Vector{T}(undef, ncy) for _ in 1:(n + 1)]
    for (i, item) in enumerate(temp_rhs)
        for (j, col) in enumerate(eachrow(reduce(hcat, item)))
            resids[i][j] = sum(abs2, col)
        end
    end
    recursive_flatten!(z, temp_z)
    residss = [r[1:ncomp] for r in resids]

    # update z in cache for next iteration
    new_z = __get_value(temp_z)
    copyto!(cache.z, new_z)
    copyto!(cache.dmz, dmz)

    return reduce(vcat, residss)
end

function Φ(cache::AscherCache{iip, T}, z, pt::TwoPointBVProblem) where {iip, T}
    (;
        f, mesh, mesh_dt, ncomp, ny, bc, k, p, zeta, residual, zval, yval,
        gval, delz, dmz, deldmz, g, w, v, dmzo, ipvtg, ipvtw, TU,
    ) = cache
    (; acol, rho) = TU
    ncy = ncomp + ny
    n = length(mesh) - 1
    Tz = eltype(z)
    dgz = similar(zval)
    df = Matrix{T}(undef, ncy, ncy)

    temp_rhs = [[Vector{T}(undef, ncy) for _ in 1:k] for _ in 1:n]
    temp_z = [Vector{Tz}(undef, ncomp) for _ in 1:(n + 1)]
    recursive_unflatten!(temp_z, z)
    rhs_bc = similar(zval)

    # zero the matrices to be computed
    fill!.(w, T(0))

    izeta = 1
    izsave = 1
    # set up the linear system of equations
    for i in 1:n
        # construct a block of a and a corresponding piece of rhs
        xii = mesh[i]
        h = mesh_dt[i]
        @views approx(cache, xii, zval)
        # find rhs boundary value
        gvalₐ = first(bc)(zval, p)
        gvalᵦ = last(bc)(zval, p)
        gval = vcat(gvalₐ, gvalᵦ)
        # go thru the ncomp collocation equations and side conditions
        # in the i-th subinterval
        while true
            (izeta > ncomp) && break
            (zeta[izeta] > xii + eps(T)) && break
            rhs_bc[izeta] = -gval[izeta]
            # build a row of a corresponding to a boundary point
            @views gderiv(cache, g[i], izeta, zval, dgz, 1, izeta, pt)
            izeta = izeta + 1
        end

        # assemble collocation equations
        for j in 1:k
            hrho = h * rho[j]
            xcol = xii + hrho
            # find rhs values
            @views approx(cache, xcol, zval, yval, dmzo[i][j][1:ncomp])
            uval = vcat(zval, yval)

            residual = f(uval, p, xcol)
            dmzo[i][j][(ncomp + 1):ncy] .= T(0)
            temp_rhs[i][j] .= residual .- dmzo[i][j]

            # fill in ncy rows of  w and v
            @views vwblok(
                cache, xcol, hrho, j, w[i], v[i], ipvtw[i], uval, df, acol[:, j], dmzo[i]
            )
        end

        @views gblock!(cache, h, g[i], izeta, w[i], v[i])

        if i >= n
            izsave = izeta
            # build equation for a side condition.
            # other nonlinear case
            zval = __get_value(cache.z[n + 1])
            gvalₐ = first(bc)(zval, p)
            gvalᵦ = last(bc)(zval, p)
            gval = vcat(gvalₐ, gvalᵦ)
            while true
                (izeta > ncomp) && break
                # find rhs boundary value
                rhs_bc[izeta] = -gval[izeta]
                # build a row of  a  corresponding to a boundary point
                @views gderiv(cache, g[i], izeta + ncomp, zval, dgz, 2, izeta, pt)
                izeta = izeta + 1
            end
        end
    end

    # assembly process completed
    # solve the linear system
    # matrix decomposition
    @views AlmostBlockDiagonals.factor_shift(g, ipvtg, df)

    # perform forward and backward substitution.
    deldmz .= copy(temp_rhs)
    izet = 1
    for i in 1:n
        nrow = g.rows[i]
        izeta = nrow + 1 - ncomp
        (i == n) && (izeta = izsave)
        while true
            (izet == izeta) && break
            delz[i][izet] = rhs_bc[izet]
            izet = izet + 1
        end
        h = mesh_dt[i]
        @views gblock!(cache, h, izeta, w[i], delz[i:(i + 1)], deldmz[i], ipvtw[i])

        if i == n
            while true
                (izet > ncomp) && break
                delz[i + 1][izet] = rhs_bc[izet]
                izet = izet + 1
            end
        end
    end
    # perform forward and backward substitution
    @views AlmostBlockDiagonals.substitution(g, ipvtg, delz)

    # finally find deldmz
    @views dmzsol!(cache, v, delz, deldmz)

    # project current iterate into current pp-space
    dmz .= copy(dmzo)
    izet::Int = 1
    for i in 1:n
        nrow = g.rows[i]
        izeta::Int = nrow + 1 - ncomp
        (i == n) && (izeta = izsave)
        while true
            (izet == izeta) && break
            temp_z[i][izet] = dgz[izet]
            izet = izet + 1
        end
        h = mesh_dt[i]
        @views gblock!(cache, h, izeta, w[i], temp_z[i:(i + 1)], dmz[i], ipvtw[i])

        if i == n
            while true
                (izet > ncomp) && break
                temp_z[i + 1][izet] = dgz[izet]
                izet = izet + 1
            end
        end
    end

    @views AlmostBlockDiagonals.substitution(g, ipvtg, temp_z)

    # finally find dmz
    @views dmzsol!(cache, v, temp_z, dmz)

    temp_z .= temp_z .+ delz
    dmz .= dmz .+ deldmz

    resids = [Vector{T}(undef, ncy) for _ in 1:(n + 1)]
    for (i, item) in enumerate(temp_rhs)
        for (j, col) in enumerate(eachrow(reduce(hcat, item)))
            resids[i][j] = sum(abs2, col)
        end
    end
    recursive_flatten!(z, temp_z)
    residss = [r[1:ncomp] for r in resids]

    # update z in cache for next iteration
    new_z = __get_value(temp_z)
    copyto!(cache.z, new_z)
    copyto!(cache.dmz, dmz)

    return reduce(vcat, residss)
end

function approx(cache::AscherCache{iip, T}, x, zval) where {iip, T}
    (; k, z, ncomp, dmz, TU, mesh, mesh_dt) = cache
    (; coef) = TU
    n = length(mesh) - 1
    a = Vector{T}(undef, 7)
    i = interval(mesh, x)
    s = (x - mesh[i]) / mesh_dt[i]
    @views rkbas!(s, coef, k, a)
    bm = x - mesh[i]
    if i == n + 1
        zval .= z[n + 1]
        return
    end
    # evaluate z(u(x))
    zsum = [sum(a[j] * dmz[i][j][jj] for j in 1:k) for jj in 1:ncomp]
    zᵢ = __get_value.(z[i])
    zsum .= zsum .* bm .+ zᵢ
    return zval .= zsum
end

function approx(cache::AscherCache{iip, T}, x, zval, yval) where {iip, T}
    (; k, z, ncomp, ny, dmz, TU, mesh, mesh_dt) = cache
    (; coef) = TU
    n = length(mesh) - 1
    dm = Vector{T}(undef, 7)
    a = Vector{T}(undef, 7)
    i = interval(mesh, x)
    s = (x - mesh[i]) / mesh_dt[i]
    @views rkbas!(s, coef, k, a, dm)
    bm = x - mesh[i]
    if i == n + 1
        zval .= z[n + 1]
        yval .= T(0)
        for j in 1:k
            yval .= yval .+ dm[j] * dmz[i - 1][j][(ncomp + 1):end]
        end
        return
    end
    # evaluate z(u(x))
    zsum = [sum(a[j] * dmz[i][j][jj] for j in 1:k) for jj in 1:ncomp]
    zᵢ = __get_value.(z[i])
    zsum .= zsum .* bm .+ zᵢ
    zval .= zsum

    # evaluate  y(j) = j-th component of y.
    yval .= T(0)
    for j in 1:k
        yval .= yval .+ dm[j] * dmz[i][j][(ncomp + 1):end]
    end
    return
end

function approx(cache::AscherCache{iip, T}, x, zval, yval, dmval) where {iip, T}
    (; k, z, ncomp, dmz, TU, mesh, mesh_dt) = cache
    (; coef) = TU
    n = length(mesh) - 1
    dm = Vector{T}(undef, 7)
    a = Vector{T}(undef, 7)
    i = interval(mesh, x)
    s = (x - mesh[i]) / mesh_dt[i]
    @views rkbas!(s, coef, k, a, dm)
    bm = x - mesh[i]
    if i == n + 1
        zval .= z[n + 1]
        yval .= T(0)
        for j in 1:k
            yval .= yval .+ dm[j] * dmz[i - 1][j][(ncomp + 1):end]
        end
        dmval .= T(0)
        for j in 1:k
            @. dmval = dmval + dm[j] * dmz[i - 1][j][1:ncomp]
        end
        return
    end
    # evaluate z(u(x))
    zsum = [sum(a[j] * dmz[i][j][jj] for j in 1:k) for jj in 1:ncomp]
    zᵢ = __get_value.(z[i])
    zsum .= zsum .* bm .+ zᵢ
    zval .= zsum

    # evaluate  y(j) = j-th component of y.
    yval .= T(0)
    for j in 1:k
        @. yval = yval + dm[j] * dmz[i][j][(ncomp + 1):end]
    end

    #  evaluate  dmval(j) = mj-th derivative of uj.
    dmval .= T(0)
    for j in 1:k
        @. dmval = dmval + dm[j] * dmz[i][j][1:ncomp]
    end
    return
end

# construct a group of ncomp rows of the matrices wi and
# corresponding to an interior collocation point
# jj=1...k
function vwblok(
        cache::AscherCache{iip, T}, xcol, hrho, jj, wi,
        vi, ipvtw, zyval, df, acol, dmzo
    ) where {iip, T}
    (; jac, k, p, ncomp, ny) = cache
    ncy = ncomp + ny
    kdy = k * ncy
    # initialize wi
    i0 = (jj - 1) * ncy
    for id in (i0 + 1):(i0 + ncomp)
        wi[id, id] = T(1)
    end

    # calculuate local basis
    ha = hrho .* acol

    @views jac(df, zyval, p, xcol)
    i1 = i0 + 1
    i2 = i0 + ncy

    # evaluate dmzo=dmzo - df*(zval,yval) once for a new mesh
    dmzo[jj] .= dmzo[jj] .- df * zyval

    # loop over the  ncomp  expressions to be set up for the
    # current collocation point.
    vi[i1:i2, :] .= df[:, 1:ncomp]
    for jcomp in 1:ncomp
        jw = jcomp
        for j in 1:k
            for iw in i1:i2
                wi[iw, jw] = wi[iw, jw] - ha[j] * vi[iw, jcomp]
            end
            jw = jw + ncy
        end
    end

    # the algebraic solution components
    for jcomp in 1:ny
        jd = ncomp + jcomp
        for id in 1:ncy
            wi[i0 + id, i0 + jd] = -df[id, ncomp + jcomp]
        end
    end

    (jj < k) && return

    # decompose the wi block and solve for the ncomp columns of vi
    # do parameter condensation
    @views __factorize!(wi, ipvtw)
    for j in 1:ncomp
        @views __substitute!(wi, ipvtw, vi[:, j])
    end
    return
end

# construct collocation matrix rows according to mode
function gblock!(cache::AscherCache, h, irow, wi, vrhsz, rhsdmz, ipvtw)
    (; TU, k, ncomp) = cache
    (; b) = TU

    rhsz = reduce(vcat, vrhsz)

    # compute local basis
    hb = @. h * b

    # compute the appropriate piece of rhsz
    @views __substitute!(wi, ipvtw, rhsdmz)

    for jcomp in 1:ncomp
        rhsz[irow + jcomp - 1] = sum(hb[j] * rhsdmz[j][jcomp] for j in 1:k)
    end
    return recursive_unflatten!(vrhsz, rhsz)
end

function gblock!(cache::AscherCache{iip, T}, h, gi, irow, wi, vi) where {iip, T}
    (; TU, k, ncomp, ny) = cache
    (; b) = TU
    ncy = ncomp + ny

    # compute local basis
    hb = @. h * b

    # branch according to mode
    # set right gi-block identity
    gi[irow:(irow + ncomp - 1), 1:ncomp] .= T(0)
    gi[irow:(irow + ncomp - 1), (ncomp + 1):end] .= T(0)
    for j in 1:ncomp
        gi[irow - 1 + j, ncomp + j] = T(1)
    end

    # compute the block gi
    for icomp in 1:ncomp
        ir = irow + icomp
        id = ir - 1
        for jcol in 1:ncomp
            ind = icomp
            rsum = T(0)
            for j in 1:k
                rsum = rsum - hb[j] * vi[ind, jcol]
                ind = ind + ncy
            end
            gi[id, jcol] = rsum
        end
        gi[id, icomp] = gi[id, icomp] - T(1)
    end
    return
end

function dmzsol!(cache::AscherCache{iip, T}, v, z, dmz) where {iip, T}
    (; k, ncomp, ny) = cache
    n = length(dmz)
    ncy = ncomp + ny
    kdy = k * ncy
    for i in 1:n
        for j in 1:ncomp
            fact = __get_value(z[i][j])
            for l in 1:kdy
                kk, jj = __locate_stage(l, ncy)
                dmz[i][kk][jj] = dmz[i][kk][jj] + fact * v[i][l, j]
            end
        end
    end
    return nothing
end

@inline function __locate_stage(l, ncy)
    (1 ≤ l ≤ ncy) && (return 1, l)
    (ncy + 1 ≤ l ≤ 2 * ncy) && (return 2, l - ncy)
    (2 * ncy + 1 ≤ l ≤ 3 * ncy) && (return 3, l - 2 * ncy)
    (3 * ncy + 1 ≤ l ≤ 4 * ncy) && (return 4, l - 3 * ncy)
    (4 * ncy + 1 ≤ l ≤ 5 * ncy) && (return 5, l - 4 * ncy)
    (5 * ncy + 1 ≤ l ≤ 6 * ncy) && (return 6, l - 5 * ncy)
    return (6 * ncy + 1 ≤ l ≤ 7 * ncy) && (return 7, l - 6 * ncy)
end

function gderiv(
        cache::AscherCache{iip, T}, gi, irow, zval, dgz,
        mode::Integer, izeta, pt::StandardBVProblem
    ) where {iip, T}
    (; ncomp, bcjac) = cache
    # construct a collocation matrix row according to mode:
    # mode = 1 - a row corresponding to a initial condition
    # mode = 2 - a row corresponding to a condition at aright
    ddg = Matrix{T}(undef, ncomp, ncomp)

    # evaluate boundary conditin jacobian
    @views bcjac(ddg, zval, nothing, nothing)
    dg = ddg[izeta, :]

    # evaluate dgz = dg * zval once for a new mesh
    dgz[izeta] = sum(dg .* zval)

    # branch according to mode
    return if mode !== 2
        # provide coefficients of the j-th linearized side condition.
        # specifically, at x=zeta(j) the j-th side condition reads
        # dg(1)*z(1) + ... +dg(ncomp)*z(ncomp) + g = 0

        # handle an initial condition
        gi[irow, 1:ncomp] .= dg
        gi[irow, (ncomp + 1):end] .= T(0)
    else
        # handle a final condition
        gi[irow, 1:ncomp] .= T(0)
        gi[irow, (ncomp + 1):end] .= dg
    end
end

function gderiv(
        cache::AscherCache{iip, T}, gi, irow, zval, dgz,
        mode::Integer, izeta, pt::TwoPointBVProblem
    ) where {iip, T}
    (; ncomp, bcjac) = cache
    # construct a collocation matrix row according to mode:
    # mode = 1 - a row corresponding to a initial condition
    # mode = 2 - a row corresponding to a condition at aright
    ddg = Matrix{T}(undef, ncomp, ncomp)

    # evaluate boundary conditin jacobian
    @views bcjac(ddg, zval, nothing)
    dg = ddg[izeta, :]

    # evaluate dgz = dg * zval once for a new mesh
    dgz[izeta] = sum(dg .* zval)

    # branch according to mode
    return if mode !== 2
        # provide coefficients of the j-th linearized side condition.
        # specifically, at x=zeta(j) the j-th side condition reads
        # dg(1)*z(1) + ... +dg(ncomp)*z(ncomp) + g = 0

        # handle an initial condition
        gi[irow, 1:ncomp] .= dg
        gi[irow, (ncomp + 1):end] .= T(0)
    else
        # handle a final condition
        gi[irow, 1:ncomp] .= T(0)
        gi[irow, (ncomp + 1):end] .= dg
    end
end

function interval(mesh, t)
    a = findfirst(x -> x ≈ t, mesh)
    # CODLAE actually evaluate the value at final mesh point at mesh[n]
    (a == length(mesh)) && (return length(mesh) - 1)
    n = length(mesh)
    return a === nothing ? (return clamp(searchsortedfirst(mesh, t) - 1, 1, n)) : a
end

@concrete struct AscherCache{iip, T} <: AbstractBoundaryValueDiffEqCache
    prob
    f
    jac
    bc
    bcjac
    k
    original_mesh
    mesh
    mesh_dt
    ncomp
    ny
    p
    zeta
    fixpnt
    alg
    pt
    f_prototype
    bcresid_prototype

    residual
    zval
    yval
    gval

    error

    g
    w
    v
    z
    y
    dmz
    delz
    deldmz
    dmzo
    dmv
    ipvtg
    ipvtw
    TU
    valstr
    nlsolve_kwargs
    optimize_kwargs
    kwargs
    verbose
end

Base.eltype(::AscherCache{iip, T}) where {iip, T} = T

function get_fixed_points(prob::BVProblem, alg::AbstractAscher)
    t₀ = prob.tspan[1]
    t₁ = prob.tspan[2]
    fixpnt = sort(alg.zeta)
    zeta = copy(alg.zeta)

    if prob.problem_type isa TwoPointBVProblem
        return zeta, Vector{eltype(zeta)}(undef, 0)
    else
        filter!(x -> (x ≉ t₀) && (x ≉ t₁), fixpnt)
        return zeta, fixpnt
    end
end

function SciMLBase.__init(
        prob::BVProblem, alg::AbstractAscher; dt = 0.0, controller = GlobalErrorControl(),
        adaptive = true, abstol = 1.0e-4, nlsolve_kwargs = (; abstol = abstol),
        optimize_kwargs = (; abstol = abstol), verbose = DEFAULT_VERBOSE, kwargs...
    )
    verbose_spec = _process_verbose_param(verbose)
    (; tspan, p) = prob
    _, T, ncy, n, u0 = __extract_problem_details(prob; dt, check_positive_dt = true)
    t₀, t₁ = tspan
    ny = ncy - rank(prob.f.mass_matrix)
    ncomp = ncy - ny

    k = alg_stage(alg)
    zeta::Vector, fixpnt = get_fixed_points(prob, alg)
    kdy = k * ncy
    @set! alg.jac_alg = concrete_jacobian_algorithm(alg.jac_alg, prob, alg)

    # initialize collocation points, constants, mesh
    n = Int(cld(t₁ - t₀, dt))
    mesh = __extract_mesh(prob.u0, t₀, t₁, n)
    mesh_dt = diff(mesh)

    TU = constructAscher(alg, T)

    residual = Vector{T}(undef, ncy)
    zval = Vector{T}(undef, ncomp)
    yval = Vector{T}(undef, ny)
    gval = Vector{T}(undef, ncomp)
    lz = [similar(zval) for _ in 1:(n + 1)]
    fill!.(lz, T(0))
    ly = [similar(yval) for _ in 1:(n + 1)]
    fill!.(ly, T(0))
    dmz = [[zeros(Float64, ncy) for _ in 1:k] for _ in 1:n]
    dmv = [[zeros(T, ncy) for _ in 1:k] for _ in 1:n]
    delz = [similar(zval) for _ in 1:(n + 1)]
    deldmz = [[zeros(ncy) for _ in 1:k] for _ in 1:n]
    dqdmz = [[zeros(ncy) for _ in 1:k] for _ in 1:n]
    w = [zeros(kdy, kdy) for _ in 1:n]
    v = [zeros(kdy, ncomp) for _ in 1:n]
    pvtg = zeros(Int, ncomp * (n + 1))
    pvtw = [zeros(Int, kdy) for _ in 1:n]
    valst = [[similar(zval) for _ in 1:4] for _ in 1:(2 * n)]

    err = [similar(zval) for _ in 1:n]

    iip = isinplace(prob)

    f,
        bc = if prob.u0 isa AbstractVector
        prob.f, prob.f.bc
    elseif iip
        vecf! = @closure (du, u, p, t) -> __vec_f!(du, u, p, t, prob.f, size(u0))
        vecbc! = @closure (r, u, p, t) -> __vec_bc!(r, u, p, t, prob.f.bc, ncomp, size(u0))
        vecf!, vecbc!
    else
        vecf = @closure (u, p, t) -> __vec_f(u, p, t, prob.f, size(u0))
        vecbc = @closure (u, p, t) -> __vec_bc(u, p, t, prob.f.bc, size(u0))
        vecf, vecbc
    end

    f_prototype = isnothing(prob.f.f_prototype) ? nothing : __vec(prob.f.f_prototype)
    bcresid_prototype, _ = __get_bcresid_prototype(prob.problem_type, prob, u0)

    if prob.f.jac === nothing
        if iip
            jac = (df, u, p, t) -> begin
                _du = similar(u)
                prob.f(_du, u, p, t)
                _f = @closure (du, u) -> prob.f(du, u, p, t)
                ForwardDiff.jacobian!(df, _f, _du, u)
                return
            end
        else
            jac = (df, u, p, t) -> begin
                _du = prob.f(u, p, t)
                _f = @closure (du, u) -> (du .= prob.f(u, p, t))
                ForwardDiff.jacobian!(df, _f, _du, u)
                return
            end
        end
    else
        jac = prob.f.jac
    end

    if prob.f.bcjac === nothing
        bcjac = construct_bc_jac(prob)
    else
        bcjac = prob.f.bcjac
    end

    g = build_almost_block_diagonals(zeta, ncomp, mesh, T)
    cache = AscherCache{iip, T}(
        prob, f, jac, bc, bcjac, k, copy(mesh), mesh, mesh_dt, ncomp, ny, p, zeta,
        fixpnt, alg, prob.problem_type, f_prototype, bcresid_prototype, residual, zval, yval, gval,
        err, g, w, v, lz, ly, dmz, delz, deldmz, dqdmz, dmv, pvtg, pvtw, TU, valst,
        nlsolve_kwargs, optimize_kwargs, (; abstol, dt, adaptive, controller, kwargs...), verbose_spec
    )
    return cache
end

function SciMLBase.solve!(cache::AscherCache{iip, T}) where {iip, T}
    (abstol, adaptive, _, _), _ = __split_kwargs(; cache.kwargs...)
    info::ReturnCode.T = ReturnCode.Success

    # We do the first iteration outside the loop to preserve type-stability of the
    # `original` field of the solution
    z, y, info, error_norm = __perform_ascher_iteration(cache, abstol, adaptive)

    if adaptive
        while SciMLBase.successful_retcode(info) && norm(error_norm) > abstol
            z, y, info, error_norm = __perform_ascher_iteration(cache, abstol, adaptive)
        end
    end
    u = [vcat(zᵢ, yᵢ) for (zᵢ, yᵢ) in zip(z, y)]

    return SciMLBase.build_solution(
        cache.prob, cache.alg, cache.original_mesh, u; retcode = info
    )
end

function __perform_ascher_iteration(cache::AscherCache{iip, T}, abstol, adaptive::Bool) where {
        iip, T,
    }
    info::ReturnCode.T = ReturnCode.Success
    nlprob = __construct_nlproblem(cache)
    solve_alg = __concrete_solve_algorithm(nlprob, cache.alg.nlsolve, cache.alg.optimize)
    kwargs = __concrete_kwargs(
        cache.alg.nlsolve, cache.alg.optimize, cache.nlsolve_kwargs, cache.optimize_kwargs,
        cache.verbose
    )
    nlsol = __internal_solve(nlprob, solve_alg; kwargs...)
    error_norm = 2 * abstol
    info = nlsol.retcode

    z = copy(cache.z)
    y = copy(cache.y)
    for (i, m) in enumerate(cache.mesh)
        @views approx(cache, m, z[i], y[i])
    end

    # Preserve dmz, and mesh for the mesh selection
    dmz = copy(cache.dmz)
    mesh = copy(cache.mesh)
    mesh_dt = copy(cache.mesh_dt)

    # Early terminate if non-adaptive
    (adaptive == false) && return z, y, info, error_norm

    # for error estimation
    # we construct a double mesh and solve the problem on halved mesh again to obtain the error estimation
    # since we got the previous convergence on the initial mesh, we utilize this as the initial guess for our next nonlinear solving
    if info == ReturnCode.Success
        halve_mesh!(cache)
        __expand_cache_for_error!(cache)

        _nlprob = __construct_nlproblem(cache)
        nlsol = solve(_nlprob, solve_alg; kwargs...)

        error_norm = error_estimate!(cache)
        if norm(error_norm) > abstol
            mesh_selector!(cache, z, dmz, mesh, mesh_dt, abstol)
            __expand_cache_for_next_iter!(cache)
        end
    else # Something bad happened
        if 2 * (length(cache.mesh) - 1) > cache.alg.max_num_subintervals
            # The solving process failed
            info = ReturnCode.Failure
        else
            # doesn't need to halve the mesh again, just use the expanded cache
            info = ReturnCode.Success # Force a restart, use the expanded cache for the next iteration
            __expand_cache_for_next_iter!(cache)
        end
    end

    return z, y, info, error_norm
end

# expand cache to compute the errors
function __expand_cache_for_error!(cache::AscherCache)
    (; ncomp, ny, mesh) = cache
    Nₙ = length(mesh)
    __append_abd!(cache)
    __append_similar!(cache.z, Nₙ)
    __append_similar!(cache.y, Nₙ)
    __append_similar!(cache.dmz, Nₙ - 1)
    __append_similar!(cache.dmv, Nₙ - 1)
    __append_similar!(cache.delz, Nₙ)
    __append_similar!(cache.deldmz, Nₙ - 1)
    __append_similar!(cache.dmzo, Nₙ - 1)
    __append_similar!(cache.w, Nₙ - 1)
    __append_similar!(cache.v, Nₙ - 1)
    __append_similar!(cache.ipvtg, Nₙ * ncomp)
    __append_similar!(cache.ipvtw, Nₙ - 1)
    __append_similar!(cache.error, Nₙ - 1)
    return cache
end

# expand the cache to start next iteration
function __expand_cache_for_next_iter!(cache::AscherCache)
    (; mesh) = cache
    Nₙ = length(mesh)
    resize!(cache.original_mesh, Nₙ)
    copyto!(cache.original_mesh, mesh)
    __append_similar!(cache.valstr, 2 * Nₙ)
    return cache
end

function __append_similar!(x::AbstractVector{T}, n) where {T}
    N = n - length(x)
    N == 0 && return x
    N < 0 && throw(ArgumentError("Cannot append a negative number of elements"))
    append!(x, [zero(T) for _ in 1:N])
    return x
end

function __append_similar!(x::AbstractVector{<:AbstractArray{T}}, n) where {
        T <:
        AbstractArray,
    }
    N = n - length(x)
    N == 0 && return x
    N < 0 && throw(ArgumentError("Cannot append a negative number of elements"))
    append!(x, [zero.(last(x)) for _ in 1:N])
    return x
end

function __append_similar!(x::AbstractVector{<:AbstractArray{T}}, n) where {T <: Real}
    N = n - length(x)
    N == 0 && return x
    N < 0 && throw(ArgumentError("Cannot append a negative number of elements"))
    append!(x, [zero(last(x)) for _ in 1:N])
    return x
end

function __append_similar(x::AbstractVector{T}, n) where {T}
    N = n - length(x)
    N == 0 && return x
    N < 0 && throw(ArgumentError("Cannot append a negative number of elements"))
    append!(x, [zero(last(x)) for _ in 1:N])
    return deepcopy(x)
end

function __append_similar(x::AbstractVector{<:AbstractArray{T}}, n) where {
        T <:
        AbstractArray,
    }
    N = n - length(x)
    N == 0 && return x
    N < 0 && throw(ArgumentError("Cannot append a negative number of elements"))
    append!(x, [zero.(last(x)) for _ in 1:N])
    return deepcopy(x)
end

function __append_similar(x::AbstractVector{<:AbstractArray{T}}, n) where {T <: Real}
    N = n - length(x)
    N == 0 && return x
    N < 0 && throw(ArgumentError("Cannot append a negative number of elements"))
    append!(x, [zero(last(x)) for _ in 1:N])
    return deepcopy(x)
end

function __construct_nlproblem(cache::AscherCache{iip, T}) where {iip, T}
    (; alg, pt, prob, f_prototype, bcresid_prototype) = cache
    (; jac_alg) = alg
    loss = if iip
        @closure (res, z, p) -> @views Φ!(cache, z, res, pt)
    else
        @closure (z, p) -> @views Φ(cache, z, pt)
    end

    lz = reduce(vcat, cache.z)
    resid_prototype = zero(lz)
    diffmode = if jac_alg.diffmode isa AutoSparse
        #AutoSparse(get_dense_ad(jac_alg.diffmode);
        #    sparsity_detector = __default_sparsity_detector(jac_alg.diffmode),
        #    coloring_algorithm = __default_coloring_algorithm(jac_alg.diffmode))
        # Ascher collocation need more generalized collocation to support AutoSparse
        get_dense_ad(jac_alg.diffmode)
    else
        jac_alg.diffmode
    end

    jac_cache = if iip
        DI.prepare_jacobian(loss, resid_prototype, diffmode, lz, Constant(cache.p))
    else
        DI.prepare_jacobian(loss, diffmode, lz, Constant(cache.p))
    end

    jac_prototype = if iip
        DI.jacobian(loss, resid_prototype, jac_cache, diffmode, lz, Constant(cache.p))
    else
        DI.jacobian(loss, jac_cache, diffmode, lz, Constant(cache.p))
    end

    jac = if iip
        @closure (
            J, u,
            p,
        ) -> __ascher_mpoint_jacobian!(J, u, diffmode, jac_cache, loss, lz, cache.p)
    else
        @closure (
            u,
            p,
        ) -> __ascher_mpoint_jacobian(
            jac_prototype, u, diffmode, jac_cache, loss, cache.p
        )
    end

    cost_fun = __build_cost(prob.f.cost, cache, cache.mesh, cache.ncomp + cache.ny)

    return __construct_internal_problem(
        prob, prob.problem_type, alg, loss, jac, jac_prototype,
        resid_prototype, bcresid_prototype, f_prototype, lz,
        cache.p, cache.ncomp, length(cache.mesh), cost_fun
    )
end

function __ascher_mpoint_jacobian!(J, x, diffmode, diffcache, loss, resid, p)
    DI.jacobian!(loss, resid, J, diffcache, diffmode, x, Constant(p))
    return nothing
end
function __ascher_mpoint_jacobian(J, x, diffmode, diffcache, loss, p)
    DI.jacobian!(loss, J, diffcache, diffmode, x, Constant(p))
    return J
end

# rebuild a new g with new mesh
function __append_abd!(cache::AscherCache)
    (; zeta, ncomp, mesh, g) = cache
    (; blocks, rows, cols, lasts) = g
    T = eltype(first(blocks))
    n = length(mesh) - 1
    ncol = 2 * ncomp
    resize!(rows, n)
    resize!(cols, n)
    fill!(cols, ncol)
    resize!(lasts, n)
    fill!(lasts, ncomp)
    # build integs (describing block structure of matrix)
    let lside = 0
        for i in 1:(n - 1)
            lside = first(findall(x::Float64 -> x > mesh[i], zeta)) - 1
            (lside == ncomp) && break
            rows[i] = ncomp + lside
        end
    end
    lasts[end] = ncol
    rows[end] = ncol
    resize!(blocks, n)
    for i in 1:n
        blocks[i] = zeros(T, rows[i], cols[i])
    end
    return
end

# Standard test BVDAE problem from the URI M. ASCHER and RAYMOND J. SPITERI paper
@testitem "Test Ascher solver on example problem 1" begin
    using BoundaryValueDiffEqAscher, SciMLBase
    function f1!(du, u, p, t)
        e = 2.7
        du[1] = (1 + u[2] - sin(t)) * u[4] + cos(t)
        du[2] = cos(t)
        du[3] = u[4]
        du[4] = (u[1] - sin(t)) * (u[4] - e^t)
    end
    function f1(u, p, t)
        e = 2.7
        return [
            (1 + u[2] - sin(t)) * u[4] + cos(t), cos(t),
            u[4], (u[1] - sin(t)) * (u[4] - e^t),
        ]
    end
    function bc1!(res, u, p, t)
        res[1] = u[1]
        res[2] = u[3] - 1
        res[3] = u[2] - sin(1.0)
    end
    function bc1(u, p, t)
        return [u[1], u[3] - 1, u[2] - sin(1.0)]
    end
    function bca1!(res, ua, p)
        res[1] = ua[1]
        res[2] = ua[3] - 1
    end
    function bcb1!(res, ub, p)
        res[1] = ub[2] - sin(1.0)
    end
    function bca1(ua, p)
        return [ua[1], ua[3] - 1]
    end
    function bcb1(ub, p)
        return [ub[2] - sin(1.0)]
    end
    function f1_analytic(u, p, t)
        return [sin(t), sin(t), 1.0, 0.0]
    end
    u01 = [0.0, 0.0, 0.0, 0.0]
    tspan1 = (0.0, 1.0)
    zeta1 = [0.0, 0.0, 1.0]
    fun_iip = ODEFunction(
        f1!, analytic = f1_analytic, mass_matrix = [
            1 0 0 0; 0 1 0 0;
            0 0 1 0; 0 0 0 0
        ]
    )
    fun_oop = ODEFunction(
        f1, analytic = f1_analytic, mass_matrix = [
            1 0 0 0; 0 1 0 0;
            0 0 1 0; 0 0 0 0
        ]
    )
    prob_iip = BVProblem(fun_iip, bc1!, u01, tspan1)
    prob_oop = BVProblem(fun_oop, bc1, u01, tspan1)
    tpprob_iip = TwoPointBVProblem(
        fun_iip, (bca1!, bcb1!), u01, tspan1, bcresid_prototype = (zeros(2), zeros(1))
    )
    tpprob_oop = TwoPointBVProblem(
        fun_oop, (bca1, bcb1), u01, tspan1, bcresid_prototype = (zeros(2), zeros(1))
    )
    prob1Arr = [prob_iip, prob_oop, tpprob_iip, tpprob_oop]
    SOLVERS = [
        alg(zeta = zeta1)
            for alg in (Ascher1, Ascher2, Ascher3, Ascher4, Ascher5, Ascher6, Ascher7)
    ]
    for i in 1:4
        for stage in (3, 4, 5, 6, 7)
            sol = solve(prob1Arr[i], SOLVERS[stage], dt = 0.01)
            @test SciMLBase.successful_retcode(sol)
            @test sol.errors[:final] < 1.0e-4
        end
    end
end

### Another BVDAE problem ###
# Comes from "Boundary value problems for differential-algebraic equations"
# by Leonid V. Kalachev and Robert E. O'Malley
@testitem "Test Ascher solver on example problem 2" begin
    using BoundaryValueDiffEqAscher, SciMLBase

    function f2!(du, u, p, t)
        du[1] = u[2] + u[3] + u[5] + 1
        du[2] = u[2] + u[4]
        du[3] = u[1] + u[5]
        du[4] = u[1] + u[2] + 1
        du[5] = u[1] + u[3]
    end

    function f2(u, p, t)
        return [
            u[2] + u[3] + u[5] + 1, u[2] + u[4], u[1] + u[5], u[1] + u[2] + 1, u[1] + u[3],
        ]
    end

    function bc2!(res, u, p, t)
        res[1] = u[1] + 1
        res[2] = u[2] + 2
        res[3] = u[3] - 1
    end
    function bc2(u, p, t)
        return [u[1] + 1, u[2] + 2, u[3] - 1]
    end
    u02 = [0.0, 0.0, 0.0, 0.0, 0.0]
    tspan2 = (0.0, 1.0)
    zeta2 = [0.0, 1.0, 1.0]
    fun2_iip = BVPFunction(
        f2!, bc2!, mass_matrix = [
            1 0 0 0 0; 0 1 0 0 0; 0 0 1 0 0;
            0 0 0 0 0; 0 0 0 0 0
        ]
    )
    fun2_oop = BVPFunction(
        f2, bc2, mass_matrix = [
            1 0 0 0 0; 0 1 0 0 0; 0 0 1 0 0;
            0 0 0 0 0; 0 0 0 0 0
        ]
    )
    prob2_iip = BVProblem(fun2_iip, u02, tspan2)
    prob2_oop = BVProblem(fun2_oop, u02, tspan2)
    prob2Arr = [prob2_iip, prob2_oop]
    SOLVERS = [
        alg(zeta = zeta2)
            for alg in (Ascher1, Ascher2, Ascher3, Ascher4, Ascher5, Ascher6, Ascher7)
    ]
    for i in 1:2
        for stage in (2, 4, 5, 6)
            sol = solve(prob2Arr[i], SOLVERS[stage], dt = 0.01, adaptive = false)
            @test SciMLBase.successful_retcode(sol)
        end
    end
end

@testitem "Test Ascher solver on example problem 3" begin
    using BoundaryValueDiffEqAscher, SciMLBase
    function f3!(du, u, p, t)
        du[1] = -u[3]
        du[2] = -u[3]
        du[3] = u[2] - sin(t - 1)
    end
    function f3(u, p, t)
        return [-u[3], -u[3], u[2] - sin(t - 1)]
    end
    function bc3!(res, u, p, t)
        res[1] = u[1]
        res[2] = u[2]
    end
    function bc3(u, p, t)
        return [u[1], u[2]]
    end
    function f3_analytic(u, p, t)
        return [sin(t - 1), sin(t - 1), -cos(t - 1)]
    end
    u03 = [0.0, 0.0, 0.0]
    tspan3 = (0.0, 1.0)
    zeta3 = [1.0, 1.0]
    fun_iip = ODEFunction(f3!, analytic = f3_analytic, mass_matrix = [1 0 0; 0 1 0; 0 0 0])
    fun_oop = ODEFunction(f3, analytic = f3_analytic, mass_matrix = [1 0 0; 0 1 0; 0 0 0])
    prob_iip = BVProblem(fun_iip, bc3!, u03, tspan3)
    prob_oop = BVProblem(fun_oop, bc3, u03, tspan3)
    prob3Arr = [prob_iip, prob_oop]
    SOLVERS = [
        alg(zeta = zeta3)
            for alg in (Ascher1, Ascher2, Ascher3, Ascher4, Ascher5, Ascher6, Ascher7)
    ]
    for i in 1:2
        for stage in (2, 3, 4, 5, 6, 7)
            sol = solve(prob3Arr[i], SOLVERS[stage], dt = 0.01)
            @test SciMLBase.successful_retcode(sol)
        end
    end
end

# JET tests have been moved to the separate QA test group (test/qa/)
